<template>
  <section compare>
    <section empty v-if="!$store.state.editor.keyPath[0]">
    </section>

    <section v-else>
      <md-content summary>
        <transition name="meta-content">
          <section v-if="expanded" keyselection>
            <rootKeyList keylist @rootkeyselected="id => rootKey1 = id" :activeValue="rootKey1" tableSource="compare"/>
            <rootKeyList keylist @rootkeyselected="id => rootKey2 = id" :activeValue="rootKey2" tableSource="compare"/>
          </section>
        </transition>
        <div bar>
          <md-button class="md-icon-button md-raised" @click="expanded = !expanded">
            <md-icon :md-src="expandIcon" />
          </md-button>
        </div>
      </md-content>

      <img v-if="rootKey1 && rootKey2 && !diffData" src="/img/hourglass_color.gif" alt="tick tock tick tock">
      <template v-else-if="rootKey1 && rootKey2 && diffData">
        <DiffRowEl diff-row v-for="diffRow in filterHeaders(diffData.headers)" :key="diffRow.columnName" :diffRow="diffRow" @follow="follow(diffRow)" :canFollow="true"></DiffRowEl>
        <DiffRowEl diff-row v-for="diffRow in diffData.meta" :key="diffRow.columnName" :diffRow="diffRow" @follow="follow(diffRow)" :canFollow="true"></DiffRowEl>
        <DiffRowEl diff-row v-for="diffRow in diffData.data" :key="diffRow.columnName" :diffRow="diffRow" @follow="follow(diffRow)" :canFollow="true"></DiffRowEl>
      </template>
    </section>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator';
import rootKeyList from '../components/editor/rootKeyList.vue';
import DiffRowEl from '../components/changes/diffRow.vue';
import { DiffData, DiffRow, getDiff } from '../lib/diffData';
import { store } from '../store';

@Component({
  components: {
    rootKeyList,
    DiffRowEl,
  },
})
export default class extends Vue {
  private rootKey1 = '';
  private rootKey2 = '';
  private expanded = true;

  private diffData: DiffData = {
    headers: [],
    meta: [],
    data: [],
  };

  get expandIcon(): string {
    if (this.expanded) {
      return '/img/md/arrow_up.svg';
    } else {
      return '/img/md/arrow_down.svg';
    }
  }

  private follow(diffrow: DiffRow) {
    store.commit.editor('setCompareTable', diffrow.refTable);
    this.rootKey1 = '';
    this.rootKey2 = '';
    this.rootKey1 = diffrow.oldVal;
    this.rootKey2 = diffrow.newVal;
  }

  private filterHeaders(headers: DiffRow[]) {
    return headers.filter(header => header.oldVal !== 'Y' || header.newVal !== 'Y');
  }

  @Watch('rootKey1')
  @Watch('rootKey2')
  private async rootKeysChanged(val: string, oldval: string) {
    if (!this.rootKey1 || !this.rootKey2) {
      return;
    }
    if (!oldval) {
      // collapse key section after first selection of left+right key
      this.expanded = false;
    }

    this.diffData = await getDiff(store.state.editor.compareTable, this.rootKey1, this.rootKey2);
  }
}
</script>

<style scoped lang="scss">
[bar] {
  display: flex;
  flex-direction: row;
  justify-content: center;
  margin-bottom: 1em;
}
[diff-row] {
  padding-left: 5px;
  padding-right: 5px;
}
[keyselection] {
  display: flex;
  flex-direction: row;
  [keylist] {
    flex: 1;
  }
}
.meta-content-enter-active, .meta-content-leave-active {
  transition: all .1s ease-in-out;
}
.meta-content-enter, .meta-content-leave-to {
  transform: translateY(-10px);
  opacity: 0;
}
</style>
